diff -urN src.orig/spam.c src/spam.c
--- src.orig/spam.c	Mon May 14 21:56:25 2007
+++ src/spam.c	Sat Mar 29 18:00:35 2008
@@ -46,6 +46,9 @@
   struct timeval select_tv;         /* and applied by PH */
   fd_set select_fd;
 #endif
+  int try_count = 3;
+
+next_attempt:
 
   /* stop compiler warning */
   result = 0;
@@ -314,6 +317,11 @@
 
   /* reading done */
   (void)close(spamd_sock);
+
+  if ((spamd_buffer == NULL) || (spamd_buffer[0] == 0)) {
+    try_count--;
+    if (try_count > 0) goto next_attempt;
+  }
 
   /* dig in the spamd output and put the report in a multiline header, if requested */
   if( sscanf(CS spamd_buffer,"SPAMD/%7s 0 EX_OK\r\nContent-length: %*u\r\n\r\n%lf/%lf\r\n%n",
